/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.readers.ReadGADGET2;

import java.io.File;
import java.util.ArrayList;
import java.util.Collections;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import org.visnow.vn.system.main.VisNow;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class GUI extends JPanel
{

    private JFileChooser dataFileChooser = new JFileChooser();
    protected Params params = new Params();
    private String lastPath = null;
    boolean silent = false;

    /**
     * Creates new form GUI
     */
    public GUI()
    {
        initComponents();
        dataFileChooser.setLocation(0, 0);
        dataFileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
        dataFileChooser.setMultiSelectionEnabled(true);
        updateGUI();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        coordsGroup = new javax.swing.ButtonGroup();
        selectButton = new javax.swing.JButton();
        rereadButton = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        fieldDescription = new javax.swing.JLabel();
        readVelocityCB = new javax.swing.JCheckBox();
        readIdCB = new javax.swing.JCheckBox();
        readTypeCB = new javax.swing.JCheckBox();
        readMassCB = new javax.swing.JCheckBox();
        readEnergyCB = new javax.swing.JCheckBox();
        readDensityCB = new javax.swing.JCheckBox();
        readTempCB = new javax.swing.JCheckBox();
        downsizeCB = new javax.swing.JCheckBox();
        downsizeSP = new javax.swing.JSpinner();
        showCB = new javax.swing.JCheckBox();
        jScrollPane2 = new javax.swing.JScrollPane();
        fileNameList = new javax.swing.JList();

        setLayout(new java.awt.GridBagLayout());

        selectButton.setText("browse");
        selectButton.setMaximumSize(new java.awt.Dimension(90, 20));
        selectButton.setMinimumSize(new java.awt.Dimension(90, 20));
        selectButton.setPreferredSize(new java.awt.Dimension(90, 20));
        selectButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                selectButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 1);
        add(selectButton, gridBagConstraints);

        rereadButton.setText("reread");
        rereadButton.setEnabled(false);
        rereadButton.setMaximumSize(new java.awt.Dimension(90, 20));
        rereadButton.setMinimumSize(new java.awt.Dimension(90, 20));
        rereadButton.setPreferredSize(new java.awt.Dimension(90, 20));
        rereadButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                rereadButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 1);
        add(rereadButton, gridBagConstraints);

        fieldDescription.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        fieldDescription.setText("null");
        fieldDescription.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        jScrollPane1.setViewportView(fieldDescription);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 12;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(6, 0, 0, 0);
        add(jScrollPane1, gridBagConstraints);

        readVelocityCB.setFont(new java.awt.Font("Dialog", 0, 11)); // NOI18N
        readVelocityCB.setText("particle velocities");
        readVelocityCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                readVelocityCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 5, 0, 5);
        add(readVelocityCB, gridBagConstraints);

        readIdCB.setFont(new java.awt.Font("Dialog", 0, 11)); // NOI18N
        readIdCB.setText("particle identifications");
        readIdCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                readIdCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        add(readIdCB, gridBagConstraints);

        readTypeCB.setFont(new java.awt.Font("Dialog", 0, 11)); // NOI18N
        readTypeCB.setText("particle types");
        readTypeCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                readTypeCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        add(readTypeCB, gridBagConstraints);

        readMassCB.setFont(new java.awt.Font("Dialog", 0, 11)); // NOI18N
        readMassCB.setText("particle masses");
        readMassCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                readMassCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        add(readMassCB, gridBagConstraints);

        readEnergyCB.setFont(new java.awt.Font("Dialog", 0, 11)); // NOI18N
        readEnergyCB.setText("internal energy");
        readEnergyCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                readEnergyCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        add(readEnergyCB, gridBagConstraints);

        readDensityCB.setFont(new java.awt.Font("Dialog", 0, 11)); // NOI18N
        readDensityCB.setText("density");
        readDensityCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                readDensityCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        add(readDensityCB, gridBagConstraints);

        readTempCB.setFont(new java.awt.Font("Dialog", 0, 11)); // NOI18N
        readTempCB.setText("calculate temperature");
        readTempCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                readTempCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        add(readTempCB, gridBagConstraints);

        downsizeCB.setFont(new java.awt.Font("Dialog", 0, 11)); // NOI18N
        downsizeCB.setText("downsize");
        downsizeCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                downsizeCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        add(downsizeCB, gridBagConstraints);

        downsizeSP.setMinimumSize(new java.awt.Dimension(36, 20));
        downsizeSP.setPreferredSize(new java.awt.Dimension(36, 20));
        downsizeSP.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                downsizeSPStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 5);
        add(downsizeSP, gridBagConstraints);

        showCB.setFont(new java.awt.Font("Dialog", 0, 11)); // NOI18N
        showCB.setText("show");
        showCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                showCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 10;
        add(showCB, gridBagConstraints);

        jScrollPane2.setMinimumSize(new java.awt.Dimension(150, 80));
        jScrollPane2.setPreferredSize(new java.awt.Dimension(180, 100));

        fileNameList.setBackground(java.awt.SystemColor.control);
        fileNameList.setFont(new java.awt.Font("Dialog", 0, 11)); // NOI18N
        fileNameList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        fileNameList.setVisibleRowCount(4);
        jScrollPane2.setViewportView(fileNameList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        add(jScrollPane2, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void selectButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_selectButtonActionPerformed
    {//GEN-HEADEREND:event_selectButtonActionPerformed
        if (lastPath == null) {
            dataFileChooser.setCurrentDirectory(new File(VisNow.get().getMainConfig().getUsableDataPath(GadgetReader.class)));
        } else {
            dataFileChooser.setCurrentDirectory(new File(lastPath));
        }

        int returnVal = dataFileChooser.showOpenDialog(this);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File[] files = dataFileChooser.getSelectedFiles();
            ArrayList<String> filePaths = new ArrayList<String>();
            for (int i = 0; i < files.length; i++) {
                filePaths.add(files[i].getAbsolutePath());
            }
            Collections.sort(filePaths);
            String[] txt = new String[filePaths.size()];
            for (int i = 0; i < txt.length; i++) {
                txt[i] = filePaths.get(i);
            }
            fileNameList.setListData(txt);
            lastPath = txt[0].substring(0, txt[0].lastIndexOf(File.separator));
            VisNow.get().getMainConfig().setLastDataPath(lastPath, GadgetReader.class);
            rereadButton.setEnabled(true);
            rereadButtonActionPerformed(null);
        }
    }//GEN-LAST:event_selectButtonActionPerformed

    private void rereadButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rereadButtonActionPerformed
        String[] txt = new String[fileNameList.getModel().getSize()];
        for (int i = 0; i < txt.length; i++) {
            txt[i] = (String) fileNameList.getModel().getElementAt(i);
        }
        if (txt != null && txt.length > 0) {
            params.setFilePaths(txt);
        }
    }//GEN-LAST:event_rereadButtonActionPerformed

    private void readVelocityCBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_readVelocityCBActionPerformed
        if (!readVelocityCB.isSelected() && getNSelected() == 1) {
            readVelocityCB.setSelected(true);
            return;
        }
        params.setReadVelocity(readVelocityCB.isSelected());
    }//GEN-LAST:event_readVelocityCBActionPerformed

    private void readIdCBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_readIdCBActionPerformed
        if (!readIdCB.isSelected() && getNSelected() == 1) {
            readIdCB.setSelected(true);
            return;
        }
        params.setReadId(readIdCB.isSelected());
    }//GEN-LAST:event_readIdCBActionPerformed

    private void readTypeCBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_readTypeCBActionPerformed
        if (!readTypeCB.isSelected() && getNSelected() == 1) {
            readTypeCB.setSelected(true);
            return;
        }
        params.setReadType(readTypeCB.isSelected());
    }//GEN-LAST:event_readTypeCBActionPerformed

    private void readMassCBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_readMassCBActionPerformed
        if (!readMassCB.isSelected() && getNSelected() == 1) {
            readMassCB.setSelected(true);
            return;
        }

        params.setReadMass(readMassCB.isSelected());
        updateGUI();
    }//GEN-LAST:event_readMassCBActionPerformed

    private void readEnergyCBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_readEnergyCBActionPerformed
        if ((!readEnergyCB.isSelected() && getNSelected() == 1) ||
            (!readEnergyCB.isSelected() && readTempCB.isSelected() && getNSelected() == 2)) {
            readEnergyCB.setSelected(true);
            return;
        }

        params.setReadEnergy(readEnergyCB.isSelected());
        if (!readEnergyCB.isSelected() && readTempCB.isSelected()) {
            readTempCB.setSelected(false);
            params.setReadTemperature(false);
        }
        readTempCB.setEnabled(readEnergyCB.isSelected());

    }//GEN-LAST:event_readEnergyCBActionPerformed

    private void readDensityCBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_readDensityCBActionPerformed
        if (!readDensityCB.isSelected() && getNSelected() == 1) {
            readDensityCB.setSelected(true);
            return;
        }
        params.setReadDensity(readDensityCB.isSelected());
    }//GEN-LAST:event_readDensityCBActionPerformed

    private void readTempCBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_readTempCBActionPerformed
        if (!readTempCB.isSelected() && getNSelected() == 1) {
            readTempCB.setSelected(true);
            return;
        }
        params.setReadTemperature(readTempCB.isSelected());
    }//GEN-LAST:event_readTempCBActionPerformed

    private void downsizeCBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_downsizeCBActionPerformed
        if (downsizeCB.isSelected()) {
            downsizeSP.setEnabled(true);
            int v = (Integer) downsizeSP.getValue();
            params.setDownsize(v);
        } else {
            downsizeSP.setEnabled(false);
            params.setDownsize(1);
        }
    }//GEN-LAST:event_downsizeCBActionPerformed

    private void downsizeSPStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_downsizeSPStateChanged
        int v = (Integer) downsizeSP.getValue();
        if (v < 1) {
            downsizeSP.setValue(1);
            return;
        }

        if (!silent) {
            params.setDownsize(v);
        }
    }//GEN-LAST:event_downsizeSPStateChanged

    private void showCBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_showCBActionPerformed
        params.setShow(showCB.isSelected());
    }//GEN-LAST:event_showCBActionPerformed

    public void setFieldDescription(String s)
    {
        fieldDescription.setText(s);
    }

    /**
     * @param params the params to set
     */
    public void setParams(Params params)
    {
        this.params = params;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup coordsGroup;
    private javax.swing.JCheckBox downsizeCB;
    private javax.swing.JSpinner downsizeSP;
    private javax.swing.JLabel fieldDescription;
    private javax.swing.JList fileNameList;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JCheckBox readDensityCB;
    private javax.swing.JCheckBox readEnergyCB;
    private javax.swing.JCheckBox readIdCB;
    private javax.swing.JCheckBox readMassCB;
    private javax.swing.JCheckBox readTempCB;
    private javax.swing.JCheckBox readTypeCB;
    private javax.swing.JCheckBox readVelocityCB;
    protected javax.swing.JButton rereadButton;
    protected javax.swing.JButton selectButton;
    private javax.swing.JCheckBox showCB;
    // End of variables declaration//GEN-END:variables
    private void updateGUI()
    {
        silent = true;
        readDensityCB.setSelected(params.isReadDensity());
        readEnergyCB.setSelected(params.isReadEnergy());
        readIdCB.setSelected(params.isReadId());
        readMassCB.setSelected(params.isReadMass());
        readTempCB.setSelected(params.isReadTemperature());
        readTypeCB.setSelected(params.isReadType());
        readVelocityCB.setSelected(params.isReadVelocity());
        downsizeCB.setSelected(params.getDownsize() != 1);
        downsizeSP.setValue(params.getDownsize());
        if (params.getDownsize() == 1) {
            downsizeCB.setSelected(false);
            downsizeSP.setEnabled(false);
        } else {
            downsizeCB.setSelected(true);
            downsizeSP.setEnabled(true);
        }
        silent = false;
    }

    private int getNSelected()
    {
        int out = 0;
        if (params.isReadDensity())
            out++;
        if (params.isReadEnergy())
            out++;
        if (params.isReadId())
            out++;
        if (params.isReadMass())
            out++;
        if (params.isReadTemperature())
            out++;
        if (params.isReadType())
            out++;
        if (params.isReadVelocity())
            out++;
        return out;
    }

    void activateOpenDialog()
    {
        selectButtonActionPerformed(null);
    }

}
